---
title: '-webkit-device-pixel-ratio'
slug: Web/CSS/@media/-webkit-device-pixel-ratio
tags:
  - '@media'
  - CSS
  - NeedsBrowserCompatibility
  - Non-standard
  - WebKit
  - media feature
---
<div>{{ CSSRef }} {{ Non-standard_header }}</div>

<p>The <strong><code>-webkit-device-pixel-ratio</code></strong> is a non-standard Boolean <a href="/en-US/docs/Web/CSS">CSS</a> <a href="/en-US/docs/Web/CSS/Media_Queries/Using_media_queries#Media_features">media feature</a> which is an alternative to the standard <a href="/en-US/docs/Web/CSS/@media/resolution"><code>resolution</code></a> media feature.</p>

<div class="note">
<p><strong>Note:</strong> This media feature is a WebKit feature. If possible, use the <a href="/en-US/docs/Web/CSS/@media/resolution"><code>resolution</code></a> media feature query instead.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<p>The <code>-webkit-device-pixel-ratio</code> feature is specified as a {{cssxref("&lt;number&gt;")}} value. It is a range feature, meaning that you can also use the prefixed <strong><code>-webkit-min-device-pixel-ratio</code></strong> and <strong><code>-webkit-max-device-pixel-ratio</code></strong> variants to query minimum and maximum values, respectively.</p>

<h3 id="Values">Values</h3>

<dl>
 <dt>{{cssxref("&lt;number&gt;")}}</dt>
 <dd>The number of device pixels used to represent each CSS <a href="/en-US/docs/Web/CSS/length#Absolute_length_units"><code>px</code></a>. Although the value is a <code>&lt;number&gt;</code>, and thus doesn't syntactically allow units, its implicit unit is <a href="/en-US/docs/Web/CSS/resolution#dppx"><code>dppx</code></a>.</dd>
</dl>

<h2 id="Implementation">Implementation</h2>

<pre class="brush: css notranslate">/* A unit of "dppx" is implied: */
@media (-webkit-min-device-pixel-ratio: 2) { ... }
/* ... is equivalent to: */
@media (min-resolution: 2dppx) { ... }

/* Similarly: */
@media (-webkit-max-device-pixel-ratio: 2) { ... }
/* ... is equivalent to: */
@media (max-resolution: 2dppx) { ... }
</pre>

<h2 id="Examples">Examples</h2>

<h3 id="HTML">HTML</h3>

<pre class="brush: html notranslate">&lt;p&gt;This is a test of your device's pixel density.&lt;/p&gt;
</pre>

<h3 id="CSS">CSS</h3>

<pre class="brush: css notranslate">/* Exact resolution */
@media (-webkit-device-pixel-ratio: 1) {
  p {
    color: red;
  }
}

/* Minimum resolution */
@media (-webkit-min-device-pixel-ratio: 1.1) {
  p {
    font-size: 1.5em;
  }
}

/* Maximum resolution */
@media (-webkit-max-device-pixel-ratio: 3) {
  p {
    background: yellow;
  }
}</pre>

<h3 id="Result">Result</h3>

<p>{{EmbedLiveSample("Example")}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('Compat', '#css-media-queries-webkit-device-pixel-ratio', '-webkit-device-pixel-ratio')}}</td>
   <td>{{Spec2('Compat')}}</td>
   <td>Initial standardization</td>
  </tr>
  <tr>
   <td><a class="external external-icon" href="https://developer.apple.com/library/safari/documentation/AppleApplications/Reference/SafariCSSRef/Articles/OtherStandardCSS3Features.html#//apple_ref/doc/uid/TP40007601-SW3" hreflang="en" lang="en">Safari CSS Reference<br>
    <small lang="en-US">'media query extensions' in that document.</small></a></td>
   <td>Non-standard unofficial documentation</td>
   <td>Initial documentation</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("css.at-rules.media.-webkit-device-pixel-ratio")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/CSS/Media_Queries/Using_media_queries">Using media queries</a></li>
 <li>{{cssxref("resolution")}}</li>
 <li><a href="/en-US/docs/Web/CSS/@media/-webkit-transform-2d"><code>-webkit-transform-2d</code></a></li>
 <li><a href="/en-US/docs/Web/CSS/@media/-webkit-transform-3d"><code>-webkit-transform-3d</code></a></li>
 <li><a href="/en-US/docs/Web/CSS/@media/-webkit-transition"><code>-webkit-transition</code></a></li>
 <li><a href="/en-US/docs/Web/CSS/@media/-webkit-animation"><code>-webkit-animation</code></a></li>
 <li><a href="https://www.w3.org/blog/CSS/2012/06/14/unprefix-webkit-device-pixel-ratio/">W3C Suggested Method to UnPrefix</a></li>
</ul>
